diff --git a/ltt/ltt-serialize.c b/ltt/ltt-serialize.c
new file mode 100644
index 0000000..2b9d1ed
--- /dev/null
+++ b/ltt/ltt-serialize.c
@@ -0,0 +1,486 @@
+/*
+ * ltt-serialize.c
+ *
+ * LTTng serializing code.
+ *
+ * Copyright Mathieu Desnoyers, March 2007.
+ *
+ * Licensed under the GPLv2.
+ */
+
+#include <stdarg.h>
+#include <linux/ctype.h>
+#include <linux/string.h>
+#include <linux/module.h>
+#include <linux/ltt-tracer.h>
+
+static int skip_atoi(const char **s)
+{
+	int i=0;
+
+	while (isdigit(**s))
+		i = i*10 + *((*s)++) - '0';
+	return i;
+}
+
+/* Inspired from vsnprintf */
+/* The serialization format string supports the basic printf format strings.
+ * In addition, it also defines new formats that can be used to serialize
+ * more complex/non portable data structures.
+ *
+ * Serialization specific formats :
+ *
+ * Fixed length struct, union or array.
+ * %*r     expects sizeof(*ptr), ptr
+ * %*.*r   expects sizeof(*ptr), __alignof__(*ptr), ptr
+ *
+ * Variable length sequence
+ * %*.*:*v expects sizeof(*ptr), __alignof__(*ptr), elem_num, ptr
+ *         where elem_num is the number of elements in the sequence
+ *
+ * Callback
+ * %k      callback (taken from the probe data)
+ *
+ * Fixed size integers
+ * %1b     expects uint8_t
+ * %2b     expects uint16_t
+ * %4b     expects uint32_t
+ * %8b     expects uint64_t
+ * %*b     expects sizeof(data), data
+ *         where sizeof(data) is 1, 2, 4 or 8
+ */
+__attribute__((no_instrument_function))
+char *ltt_serialize_data(char *buffer, char *str,
+			struct ltt_serialize_closure *closure,
+			int align,
+			const char *fmt, va_list *args)
+{
+	const char *s;
+	int elem_size;		/* Size of the integer for 'b' */
+				/* Size of the data contained by 'r' */
+	int elem_alignment;	/* Element alignment for 'r' */
+	int elem_num;		/* Number of elements in 'v' */
+	int qualifier;		/* 'h', 'l', or 'L' for integer fields */
+				/* 'z' support added 23/7/1999 S.H.    */
+				/* 'z' changed to 'Z' --davidm 1/25/99 */
+				/* 't' added for ptrdiff_t */
+
+	for (; *fmt ; ++fmt) {
+		if (*fmt != '%') {
+			/* Skip text */
+			continue;
+		}
+
+		/* process flags : ignore standard print formats for now. */
+		repeat:
+			++fmt;		/* this also skips first '%' */
+			switch (*fmt) {
+				case '-':
+				case '+':
+				case ' ':
+				case '#':
+				case '0': goto repeat;
+			}
+
+		/* get element size */
+		elem_size = -1;
+		if (isdigit(*fmt))
+			elem_size = skip_atoi(&fmt);
+		else if (*fmt == '*') {
+			++fmt;
+			/* it's the next argument */
+			elem_size = va_arg(*args, int);
+		}
+
+		/* get the alignment */
+		elem_alignment = -1;
+		if (*fmt == '.') {
+			++fmt;	
+			if (isdigit(*fmt))
+				elem_alignment = skip_atoi(&fmt);
+			else if (*fmt == '*') {
+				++fmt;
+				/* it's the next argument */
+				elem_alignment = va_arg(*args, int);
+			}
+		}
+
+		/* get the number of elements */
+		elem_num = -1;
+		if (*fmt == ':') {
+			++fmt;	
+			if (isdigit(*fmt))
+				elem_num = skip_atoi(&fmt);
+			else if (*fmt == '*') {
+				++fmt;
+				/* it's the next argument */
+				elem_num = va_arg(*args, int);
+			}
+		}
+
+		/* get the conversion qualifier */
+		qualifier = -1;
+		if (*fmt == 'h' || *fmt == 'l' || *fmt == 'L' ||
+		    *fmt =='Z' || *fmt == 'z' || *fmt == 't' ||
+		    *fmt == 'S') {
+			qualifier = *fmt;
+			++fmt;
+			if (qualifier == 'l' && *fmt == 'l') {
+				qualifier = 'L';
+				++fmt;
+			}
+		}
+
+		switch (*fmt) {
+			case 'c':
+				if (buffer)
+					*str = (char)va_arg(*args, int);
+				else
+					(void)va_arg(*args, int);
+				str += sizeof(char);
+				continue;
+
+			case 's':
+				s = va_arg(*args, const char *);
+				if ((unsigned long)s < PAGE_SIZE)
+					s = "<NULL>";
+				elem_size = strlen(s)+1;
+				if (buffer)
+					memcpy(str, s, elem_size);
+				str += elem_size;
+				/* Following alignment for genevent
+				 * compatibility */
+				if (align)
+					str += ltt_align((long)str,
+							sizeof(void*));
+				continue;
+
+			case 'p':
+				if (align)
+					str += ltt_align((long)str,
+							sizeof(void*));
+				if (buffer)
+					*(void**)str = va_arg(*args, void *);
+				else
+					(void)va_arg(*args, void *);
+				str += sizeof(void*);
+				continue;
+
+			case 'r':
+				/* For array, struct, union */
+				if (elem_alignment > 0 && align)
+					str += ltt_align((long)str,
+							elem_alignment);
+				s = va_arg(*args, const char *);
+				if (elem_size > 0) {
+					if (buffer)
+						memcpy(str, s, elem_size);
+					str += elem_size;
+				}
+				continue;
+
+			case 'v':
+				/* For sequence */
+				if (align)
+					str += ltt_align((long)str,
+						max((int)sizeof(int),
+						elem_alignment));
+				if (buffer)
+					*(int*)str = elem_num;
+				str += sizeof(int);
+				if (elem_alignment > 0 && align)
+					str += ltt_align((long)str,
+						elem_alignment);
+				s = va_arg(*args, const char *);
+				if (elem_num > 0) {
+					if (buffer)
+						memcpy(str, s,
+							elem_num*elem_size);
+					str += elem_num*elem_size;
+				}
+				/* Following alignment for genevent
+				 * compatibility */
+				if (align)
+					str += ltt_align((long)str,
+							sizeof(void*));
+				continue;
+
+			case 'k':
+				/* For callback */
+				 /* The callback will take as many arguments
+				  * as it needs from args. They won't be
+				  * type verified. */
+				if (closure->cb_idx < LTT_NR_CALLBACKS-1) {
+					ltt_serialize_cb cb;
+					closure->cb_idx++;
+					cb = closure->callbacks[closure->cb_idx];
+					str = cb(buffer, str, closure,
+							align,
+							fmt, args);
+				}
+				continue;
+
+			case 'n':
+				/* FIXME:
+				* What does C99 say about the overflow case
+				* here? */
+				if (qualifier == 'l') {
+					long * ip = va_arg(*args, long *);
+					*ip = (str - buffer);
+				} else if (qualifier == 'Z'
+					|| qualifier == 'z') {
+					size_t * ip = va_arg(*args, size_t *);
+					*ip = (str - buffer);
+				} else {
+					int * ip = va_arg(*args, int *);
+					*ip = (str - buffer);
+				}
+				continue;
+
+			case '%':
+				continue;
+
+			case 'b':
+				if (elem_size < 0)
+					elem_size = 0;
+				if (elem_size > 0 && align)
+					str += ltt_align((long)str, elem_size);
+				switch (elem_size) {
+				case 1:
+					if (buffer)
+						*(int8_t*)str =
+						(int8_t)va_arg(*args, int);
+					else
+						(void)va_arg(*args, int);
+					break;
+				case 2:
+					if (buffer)
+						*(int16_t*)str =
+						(int16_t)va_arg(*args, int);
+					else
+						(void)va_arg(*args, int);
+					break;
+				case 4:
+					if (buffer)
+						*(int32_t*)str =
+						va_arg(*args, int32_t);
+					else
+						(void)va_arg(*args, int32_t);
+					break;
+				case 8:
+					if (buffer)
+						*(int64_t*)str =
+						va_arg(*args, int64_t);
+					else
+						(void)va_arg(*args, int64_t);
+					break;
+				}
+				str += elem_size;
+				continue;
+
+			case 'o':
+			case 'X':
+			case 'x':
+			case 'd':
+			case 'i':
+			case 'u':
+				break;
+
+			default:
+				if (!*fmt)
+					--fmt;
+				continue;
+		}
+		switch (qualifier) {
+		case 'L':
+			if (align)
+				str += ltt_align((long)str, sizeof(long long));
+			if (buffer)
+				*(long long*)str = va_arg(*args, long long);
+			else
+				(void)va_arg(*args, long long);
+			str += sizeof(long long);
+			break;
+		case 'l':
+			if (align)
+				str += ltt_align((long)str, sizeof(long));
+			if (buffer)
+				*(long*)str = va_arg(*args, long);
+			else
+				(void)va_arg(*args, long);
+			str += sizeof(long);
+			break;
+		case 'Z':
+		case 'z':
+			if (align)
+				str += ltt_align((long)str, sizeof(size_t));
+			if (buffer)
+				*(size_t*)str = va_arg(*args, size_t);
+			else
+				(void)va_arg(*args, size_t);
+			str += sizeof(size_t);
+			break;
+		case 't':
+			if (align)
+				str += ltt_align((long)str, sizeof(ptrdiff_t));
+			if (buffer)
+				*(ptrdiff_t*)str = va_arg(*args, ptrdiff_t);
+			else
+				(void)va_arg(*args, ptrdiff_t);
+			str += sizeof(ptrdiff_t);
+			break;
+		case 'h':
+			if (align)
+				str += ltt_align((long)str, sizeof(short));
+			if (buffer)
+				*(short*)str = (short) va_arg(*args, int);
+			else
+				(void)va_arg(*args, int);
+			str += sizeof(short);
+			break;
+		default:
+			if (align)
+				str += ltt_align((long)str, sizeof(int));
+			if (buffer)
+				*(int*)str = va_arg(*args, int);
+			else
+				(void)va_arg(*args, int);
+			str += sizeof(int);
+		}
+	}
+	return str;
+}
+EXPORT_SYMBOL_GPL(ltt_serialize_data);
+
+/* Calculate data size */
+/* Assume that the padding for alignment starts at a
+ * sizeof(void *) address. */
+static __attribute__((no_instrument_function))
+size_t ltt_get_data_size(struct ltt_serialize_closure *closure,
+				int align,
+				const char *fmt, va_list *args)
+{
+	ltt_serialize_cb cb = closure->callbacks[0];
+	closure->cb_idx = 0;
+	return (size_t)cb(NULL, NULL, closure, align, fmt, args);
+}
+
+static __attribute__((no_instrument_function))
+void ltt_write_event_data(char *buffer,
+				struct ltt_serialize_closure *closure,
+				int align,
+				const char *fmt, va_list *args)
+{
+	ltt_serialize_cb cb = closure->callbacks[0];
+	closure->cb_idx = 0;
+	cb(buffer, buffer, closure, align, fmt, args);
+}
+
+
+__attribute__((no_instrument_function))
+void ltt_vtrace(const struct __mark_marker_data *mdata,
+		const char *fmt, va_list args)
+{
+	int flags;
+	int align;
+	struct ltt_probe_data *pdata;
+	uint8_t fID, eID;
+	size_t data_size, slot_size;
+	int channel_index;
+	struct ltt_channel_struct *channel;
+	struct ltt_trace_struct *trace, *dest_trace = NULL;
+	void *transport_data;
+	uint64_t tsc;
+	char *buffer;
+	va_list args_copy;
+	struct ltt_serialize_closure closure;
+	unsigned long irqflags;
+
+	flags = mdata->flags;
+	pdata = (struct ltt_probe_data *)mdata->pdata;
+	fID = pdata->fID;
+	eID = pdata->eID;
+	align = pdata->align;
+	closure.callbacks = pdata->callbacks;
+
+	/* This test is useful for quickly exiting static tracing when no
+	 * trace is active. */
+	if (likely(ltt_traces.num_active_traces == 0
+		&& !(flags & ltt_flag_mask(LTT_FLAG_FORCE))))
+		return;
+
+	ipipe_preempt_disable(irqflags);
+	ltt_nesting[ipipe_processor_id()]++;
+	
+	if (unlikely(flags & ltt_flag_mask(LTT_FLAG_TRACE)))
+		dest_trace = va_arg(args, struct ltt_trace_struct *);
+	if (unlikely(flags & ltt_flag_mask(LTT_FLAG_CHANNEL)))
+		channel_index = va_arg(args, int);
+	else
+		channel_index = pdata->channel_index;
+	/* Force write in the compact channel if compact flag is used */
+	if (unlikely(flags & ltt_flag_mask(LTT_FLAG_COMPACT)))
+		channel_index = GET_CHANNEL_INDEX(compact);
+
+	va_copy(args_copy, args);
+	/* Skip the compact data for size calculation */
+	if (likely(flags & ltt_flag_mask(LTT_FLAG_COMPACT_DATA)))
+		(void)va_arg(args_copy, u32);
+	data_size = ltt_get_data_size(&closure, align, fmt, &args_copy);
+	va_end(args_copy);
+
+	/* Iterate on each traces */
+	list_for_each_entry_rcu(trace, &ltt_traces.head, list) {
+		if (unlikely(!trace->active
+			&& !(flags & ltt_flag_mask(LTT_FLAG_FORCE))))
+			continue;
+		if (unlikely(flags & ltt_flag_mask(LTT_FLAG_TRACE)
+			&& trace != dest_trace))
+			continue;
+		if (!ltt_run_filter(trace, fID, eID))
+			continue;
+		channel = ltt_get_channel_from_index(trace, channel_index);
+		/* reserve space : header and data */
+		buffer = ltt_reserve_slot(trace, channel, &transport_data,
+						data_size, &slot_size, &tsc);
+		if (unlikely(!buffer))
+			continue; /* buffer full */
+
+		va_copy(args_copy, args);
+		/* Out-of-order write : header and data */
+		if (likely(!(flags & ltt_flag_mask(LTT_FLAG_COMPACT))))
+			buffer = ltt_write_event_header(trace, channel, buffer,
+						fID, eID, data_size, tsc);
+		else {
+			u32 compact_data = 0;
+			if (likely(flags &
+					ltt_flag_mask(LTT_FLAG_COMPACT_DATA)))
+				compact_data = va_arg(args_copy, u32);
+			buffer = ltt_write_compact_header(trace, channel,
+						buffer, fID, eID, data_size,
+						tsc, compact_data);
+		}
+		ltt_write_event_data(buffer, &closure, align, fmt, &args_copy);
+		va_end(args_copy);
+		/* Out-of-order commit */
+		ltt_commit_slot(channel, &transport_data, buffer, slot_size);
+	}
+	ltt_nesting[ipipe_processor_id()]--;
+	ipipe_preempt_enable(irqflags);
+}
+EXPORT_SYMBOL_GPL(ltt_vtrace);
+
+__attribute__((no_instrument_function))
+void ltt_trace(const struct __mark_marker_data *mdata, const char *fmt, ...)
+{
+	va_list args;
+
+	va_start(args, fmt);
+	ltt_vtrace(mdata, fmt, args);
+	va_end(args);
+}
+EXPORT_SYMBOL_GPL(ltt_trace);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION("Linux Trace Toolkit Next Generation Serializer");
diff --git a/ltt/ltt-statedump.c b/ltt/ltt-statedump.c
new file mode 100644
index 0000000..2ddcc29
--- /dev/null
+++ b/ltt/ltt-statedump.c
@@ -0,0 +1,370 @@
+/* ltt-statedump.c
+ *
+ * Linux Trace Toolkit Kernel State Dump
+ *
+ * Copyright 2005 -
+ * Jean-Hugues Deschenes <jean-hugues.deschenes@polymtl.ca>
+ *
+ * Changes:
+ *	Eric Clement:           Add listing of network IP interface
+ *	Mathieu Desnoyers	Fix kernel threads
+ */
+
+#include <linux/init.h>
+#include <linux/module.h>
+#include <linux/ltt-tracer.h>
+#include <linux/netlink.h>
+#include <linux/inet.h>
+#include <linux/ip.h>
+#include <linux/kthread.h>
+#include <linux/proc_fs.h>
+#include <linux/file.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <linux/cpu.h>
+#include <linux/netdevice.h>
+#include <linux/inetdevice.h>
+#include <linux/sched.h>
+#include <linux/mm.h>
+#include <linux/marker.h>
+
+#define NB_PROC_CHUNK 20
+
+static atomic_t kernel_threads_to_run;
+static struct delayed_work cpu_work[NR_CPUS];
+static struct task_struct *work_wake_task;
+
+enum lttng_thread_type {
+	LTTNG_USER_THREAD = 0,
+	LTTNG_KERNEL_THREAD = 1,
+};
+
+enum lttng_execution_mode {
+	LTTNG_USER_MODE = 0,
+	LTTNG_SYSCALL = 1,
+	LTTNG_TRAP = 2,
+	LTTNG_IRQ = 3,
+	LTTNG_SOFTIRQ = 4,
+	LTTNG_MODE_UNKNOWN = 5,
+};
+
+enum lttng_execution_submode {
+	LTTNG_NONE = 0,
+	LTTNG_UNKNOWN = 1,
+};
+
+enum lttng_process_status {
+	LTTNG_UNNAMED = 0,
+	LTTNG_WAIT_FORK = 1,
+	LTTNG_WAIT_CPU = 2,
+	LTTNG_EXIT = 3,
+	LTTNG_ZOMBIE = 4,
+	LTTNG_WAIT = 5,
+	LTTNG_RUN = 6,
+	LTTNG_DEAD = 7,
+};
+
+enum lttng_interface_state {
+	LTTNG_UP = 0,
+	LTTNG_DOWN = 1,
+};
+
+/* in modules.c */
+extern void list_modules(void);
+
+#ifdef CONFIG_INET
+static void ltt_enumerate_device(struct net_device *dev)
+{
+	struct in_device *in_dev;
+	struct in_ifaddr *ifa;
+
+	if (dev->flags & IFF_UP) {	
+		in_dev = in_dev_get(dev);
+		if (in_dev) {
+			for (ifa = in_dev->ifa_list;
+					ifa != NULL;
+					ifa = ifa->ifa_next) {
+				MARK(list_network_ip_interface, "%s %4b %d",
+					dev->name, ifa->ifa_address, LTTNG_UP);
+			}
+			in_dev_put(in_dev);		
+		}
+	} else
+		MARK(list_network_ip_interface, "%s %4b %d",
+			dev->name, 0, LTTNG_DOWN);
+}
+
+static inline int ltt_enumerate_network_ip_interface(void)
+{
+	struct net_device *list;
+	
+	read_lock(&dev_base_lock);
+	for (list = dev_base; list != NULL; list = list->next)
+		ltt_enumerate_device(list);
+	read_unlock(&dev_base_lock);
+	
+	return 0;
+}
+#else /* CONFIG_INET */
+static inline int ltt_enumerate_network_ip_interface(void)
+{
+	return 0;
+}
+#endif /* CONFIG_INET */
+
+
+static inline void ltt_enumerate_task_fd(struct task_struct *t,
+		char *tmp)
+{
+	struct fdtable *fdt;
+	struct file * filp;
+	unsigned int i;
+	const unsigned char *path;
+
+	if (!t->files)
+		return;
+
+	spin_lock(&t->files->file_lock);
+	fdt = files_fdtable(t->files);
+	for (i = 0; i < fdt->max_fds; i++) {
+		filp = fcheck_files(t->files, i);
+		if (!filp)
+			continue;
+		path = d_path(filp->f_dentry,
+				filp->f_vfsmnt, tmp, PAGE_SIZE);
+		/* Make sure we give at least some info */
+		MARK(list_file_descriptor, "%s %d %u",
+			(IS_ERR(path))?(filp->f_dentry->d_name.name):(path),
+			t->pid, i);
+	}
+	spin_unlock(&t->files->file_lock);
+}
+
+static inline int ltt_enumerate_file_descriptors(void)
+{
+	struct task_struct * t = &init_task;
+	char *tmp = (char*)__get_free_page(GFP_KERNEL);
+
+	/* Enumerate active file descriptors */
+	do {
+		read_lock(&tasklist_lock);
+		if (t != &init_task)
+			atomic_dec(&t->usage);
+		t = next_task(t);
+		atomic_inc(&t->usage);
+		read_unlock(&tasklist_lock);
+		task_lock(t);
+		ltt_enumerate_task_fd(t, tmp);
+		task_unlock(t);
+	} while (t != &init_task);
+	free_page((unsigned long)tmp);
+	return 0;
+}
+
+static inline void ltt_enumerate_task_vm_maps(struct task_struct *t)
+{
+	struct mm_struct *mm;
+	struct vm_area_struct *	map;
+	unsigned long ino;
+
+	/* get_task_mm does a task_lock... */
+	mm = get_task_mm(t);
+	if (!mm)
+		return;
+
+	map = mm->mmap;
+	if (map) {
+		down_read(&mm->mmap_sem);
+		while (map) {
+			if (map->vm_file)
+				ino = map->vm_file->f_dentry->d_inode->i_ino;
+			else
+				ino = 0;
+			MARK(list_vm_map, "%d %lu %lu %lu %lu %lu",
+					t->pid,
+					map->vm_start,
+					map->vm_end,
+					map->vm_flags,
+					map->vm_pgoff << PAGE_SHIFT,
+					ino);
+			map = map->vm_next;
+		}
+		up_read(&mm->mmap_sem);
+	}
+	mmput(mm);
+}
+
+static inline int ltt_enumerate_vm_maps(void)
+{
+	struct task_struct *  t = &init_task;
+	
+	do {
+		read_lock(&tasklist_lock);
+		if (t != &init_task)
+			atomic_dec(&t->usage);
+		t = next_task(t);
+		atomic_inc(&t->usage);
+		read_unlock(&tasklist_lock);
+		ltt_enumerate_task_vm_maps(t);
+ 	} while (t != &init_task);
+	return 0;
+}
+
+static inline void list_interrupts(void)
+{
+	unsigned int i;
+	unsigned long flags = 0;
+
+	/* needs irq_desc */
+	for (i = 0; i < NR_IRQS; i++) {
+		struct irqaction * action;
+		const char *irq_chip_name =
+			irq_desc[i].chip->name ? : "unnamed_irq_chip";
+
+		spin_lock_irqsave(&irq_desc[i].lock, flags);
+		for (action = irq_desc[i].action;
+			action; action = action->next) {
+			MARK(list_interrupt, "%s %s %u",
+				irq_chip_name, action->name, i);
+		}
+		spin_unlock_irqrestore(&irq_desc[i].lock, flags);
+	}
+}
+
+static inline int ltt_enumerate_process_states(void)
+{
+	struct task_struct *t = &init_task;
+	struct task_struct *p = t;
+	enum lttng_process_status status;
+	enum lttng_thread_type type;
+	enum lttng_execution_mode mode;
+	enum lttng_execution_submode submode;
+	
+	do {
+		mode = LTTNG_MODE_UNKNOWN;
+		submode = LTTNG_UNKNOWN;
+
+		read_lock(&tasklist_lock);
+		if (t != &init_task) {
+			atomic_dec(&t->usage);
+			t = next_thread(t);
+		}
+		if (t == p) {
+			t = p = next_task(t);
+		}
+		atomic_inc(&t->usage);
+		read_unlock(&tasklist_lock);
+		
+		task_lock(t);
+		
+		if (t->exit_state == EXIT_ZOMBIE)
+			status = LTTNG_ZOMBIE;
+		else if (t->exit_state == EXIT_DEAD)
+			status = LTTNG_DEAD;
+		else if (t->state == TASK_RUNNING) {
+			/* Is this a forked child that has not run yet? */
+			if (list_empty(&t->run_list))
+				status = LTTNG_WAIT_FORK;
+			else
+				/* All tasks are considered as wait_cpu;
+				 * the viewer will sort out if the task was
+				 * really running at this time. */
+				status = LTTNG_WAIT_CPU;
+		}
+		else if (t->state & 
+			(TASK_INTERRUPTIBLE | TASK_UNINTERRUPTIBLE)) {
+			/* Task is waiting for something to complete */
+			status = LTTNG_WAIT;
+		}
+		else
+			status = LTTNG_UNNAMED;
+		submode = LTTNG_NONE;
+
+		/* Verification of t->mm is to filter out kernel threads;
+		 * Viewer will further filter out if a user-space thread was
+		 * in syscall mode or not */
+		if (t->mm)
+			type = LTTNG_USER_THREAD;
+		else
+			type = LTTNG_KERNEL_THREAD;
+			
+		MARK(list_process_state, "%d %d %s %d %d %d %d %d",
+				t->pid, t->parent->pid, t->comm,
+				type, mode, submode, status, t->tgid);
+		task_unlock(t);
+	} while (t != &init_task);
+
+	return 0;
+}
+
+void ltt_statedump_work_func(struct work_struct *work)
+{
+	if (atomic_dec_and_test(&kernel_threads_to_run)) {
+		/* If we are the last thread, wake up do_ltt_statedump */
+		wake_up_process(work_wake_task);
+	}
+}
+
+static int do_ltt_statedump(void)
+{
+	int cpu;
+
+	printk(KERN_DEBUG "do_ltt_statedump\n");
+ 	ltt_enumerate_process_states();
+	ltt_enumerate_file_descriptors();
+	list_modules();
+	ltt_enumerate_vm_maps();
+	list_interrupts();
+	ltt_enumerate_network_ip_interface();
+	
+	/* Fire off a work queue on each CPU. Their sole purpose in life
+	 * is to guarantee that each CPU has been in a state where is was in
+	 * syscall mode (i.e. not in a trap, an IRQ or a soft IRQ) */
+	lock_cpu_hotplug();
+	atomic_set(&kernel_threads_to_run, num_online_cpus());
+	work_wake_task = current;
+	__set_current_state(TASK_UNINTERRUPTIBLE);
+	for_each_online_cpu(cpu) {
+		INIT_DELAYED_WORK(&cpu_work[cpu], ltt_statedump_work_func);
+		schedule_delayed_work_on(cpu,&cpu_work[cpu],0);
+	}
+	unlock_cpu_hotplug();
+	/* Wait for all threads to run */
+	schedule();
+	BUG_ON(atomic_read(&kernel_threads_to_run) != 0);
+	/* Our work is done */
+	printk(KERN_DEBUG "do_ltt_statedump end\n");
+	MARK(list_statedump_end, MARK_NOARGS);
+	return 0;
+}
+
+int ltt_statedump_start(struct ltt_trace_struct *trace)
+{
+	printk(KERN_DEBUG "ltt_statedump_start\n");
+
+	return do_ltt_statedump();
+}
+
+/* Dynamic facility. */
+static int __init statedump_init(void)
+{
+	int ret;
+	printk(KERN_INFO "LTT : ltt-facility-statedump init\n");
+	ret = ltt_module_register(LTT_FUNCTION_STATEDUMP,
+			ltt_statedump_start,THIS_MODULE);
+	return ret;
+}
+
+static void __exit statedump_exit(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-statedump exit\n");
+	ltt_module_unregister(LTT_FUNCTION_STATEDUMP);
+}
+
+module_init(statedump_init)
+module_exit(statedump_exit)
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Jean-Hugues Deschenes");
+MODULE_DESCRIPTION("Linux Trace Toolkit Statedump");
+
diff --git a/ltt/ltt-syscall.c b/ltt/ltt-syscall.c
new file mode 100644
index 0000000..f9e6f80
--- /dev/null
+++ b/ltt/ltt-syscall.c
@@ -0,0 +1,181 @@
+/******************************************************************************
+ * ltt-syscall.c
+ *
+ * Mathieu Desnoyers (mathieu.desnoyers@polymtl.ca)
+ * March 2006
+ *
+ * LTT userspace tracing syscalls
+ */
+
+#include <linux/errno.h>
+#include <linux/syscalls.h>
+#include <linux/sched.h>
+#include <linux/ltt-facilities.h>
+#include <linux/ltt-tracer.h>
+
+#include <asm/uaccess.h>
+
+/* User event logging function */
+static inline int trace_user_event(unsigned int facility_id,
+		unsigned int event_id,
+		void __user *data, size_t data_size, int blocking,
+		int high_priority)
+{
+	int ret = 0;
+	unsigned int index;
+	struct ltt_channel_struct *channel;
+	struct ltt_trace_struct *trace;
+	void *transport_data;
+	void *buffer = NULL;
+	size_t real_to_base = 0; /* buffer allocated on arch_size alignment */
+	size_t *to_base = &real_to_base;
+	size_t real_to = 0;
+	size_t *to = &real_to;
+	size_t real_len = 0;
+	size_t *len = &real_len;
+	size_t reserve_size;
+	size_t slot_size;
+	u64 tsc;
+	struct user_dbg_data dbg;
+
+	dbg.avail_size = 0;
+	dbg.write = 0;
+	dbg.read = 0;
+
+	if (ltt_traces.num_active_traces == 0)
+		return 0;
+
+	/* Assume that the padding for alignment starts at a
+	 * sizeof(void *) address. */
+
+	reserve_size = data_size;
+
+	if (high_priority)
+		index = GET_CHANNEL_INDEX(processes);
+	else
+		index = GET_CHANNEL_INDEX(cpu);
+
+	preempt_disable();
+
+	if (blocking) {
+		/* User space requested blocking mode :
+		 * If one of the active traces has free space below a specific
+		 * threshold value, we reenable preemption and block. */
+block_test_begin:
+		list_for_each_entry_rcu(trace, &ltt_traces.head, list) {
+			if (!trace->active)
+  				continue;
+
+			if (trace->ops->user_blocking(trace, index, data_size,
+							&dbg))
+ 				goto block_test_begin;
+		}
+	}
+	ltt_nesting[smp_processor_id()]++;
+	list_for_each_entry_rcu(trace, &ltt_traces.head, list) {
+		if (!trace->active)
+			continue;
+		channel = ltt_get_channel_from_index(trace, index);
+		slot_size = 0;
+		buffer = ltt_reserve_slot(trace, channel, &transport_data,
+			reserve_size, &slot_size, &tsc);
+		if (!buffer) {
+			if (blocking)
+				trace->ops->user_errors(trace,
+					index, data_size, &dbg);
+			continue; /* buffer full */
+		}
+		*to_base = *to = *len = 0;
+		buffer = ltt_write_event_header(trace, channel, buffer,
+			facility_id, event_id,
+			reserve_size, tsc);
+		/* Hope the user pages are not swapped out. In the rare case
+		 * where it is, the slot will be zeroed and EFAULT returned. */
+		if (__copy_from_user_inatomic(buffer+*to_base+*to, data,
+					data_size))
+			ret = -EFAULT;	/* Data is garbage in the slot */
+		ltt_commit_slot(channel, &transport_data, buffer, slot_size);
+		if (ret != 0)
+			break;
+	}
+	ltt_nesting[smp_processor_id()]--;
+	preempt_enable_no_resched();
+	return ret;
+}
+
+asmlinkage long sys_ltt_trace_generic(unsigned int facility_id,
+		unsigned int event_id,
+		void __user *data,
+		size_t data_size,
+		int blocking,
+		int high_priority)
+{
+	if (!ltt_facility_user_access_ok(facility_id))
+		return -EPERM;
+	if (!access_ok(VERIFY_READ, data, data_size))
+			return -EFAULT;
+	
+	return trace_user_event(facility_id, event_id, data, data_size,
+			blocking, high_priority);
+}
+
+asmlinkage long sys_ltt_register_generic(unsigned int __user *facility_id,
+		const struct user_facility_info __user *info)
+{
+	struct user_facility_info kinfo;
+	int fac_id;
+	unsigned int i;
+
+	/* Check if the process has already registered the maximum number of 
+	 * allowed facilities */
+	if (current->ltt_facilities[LTT_FAC_PER_PROCESS-1] != 0)
+		return -EPERM;
+	
+	if (copy_from_user(&kinfo, info, sizeof(*info)))
+		return -EFAULT;
+
+	/* Verify if facility is already registered */
+	printk(KERN_DEBUG "LTT register generic for %s\n", kinfo.name);
+	fac_id = ltt_facility_verify(LTT_FACILITY_TYPE_USER,
+				kinfo.name,
+				kinfo.num_events,
+				kinfo.checksum,
+				kinfo.int_size,
+				kinfo.long_size,
+				kinfo.pointer_size,
+				kinfo.size_t_size,
+				kinfo.alignment);
+	
+	printk(KERN_DEBUG "LTT verify return %d\n", fac_id);
+	if (fac_id > 0)
+		goto found;
+	
+	fac_id = ltt_facility_register(LTT_FACILITY_TYPE_USER,
+				kinfo.name,
+				kinfo.num_events,
+				kinfo.checksum,
+				kinfo.int_size,
+				kinfo.long_size,
+				kinfo.pointer_size,
+				kinfo.size_t_size,
+				kinfo.alignment);
+
+	printk(KERN_DEBUG "LTT register return %d\n", fac_id);
+	if (fac_id == 0)
+		return -EPERM;
+	if (fac_id < 0)
+		return fac_id;	/* Error */
+found:
+	get_task_struct(current->group_leader);
+	for (i = 0; i < LTT_FAC_PER_PROCESS; i++) {
+		if (current->group_leader->ltt_facilities[i] == 0) {
+			current->group_leader->ltt_facilities[i] =
+				(uint8_t)fac_id;
+			break;
+		}
+	}
+	put_task_struct(current->group_leader);
+	/* Write facility_id */
+	put_user((unsigned int)fac_id, facility_id);
+	return 0;
+}
diff --git a/ltt/ltt-test-tsc.c b/ltt/ltt-test-tsc.c
new file mode 100644
index 0000000..fd1138e
--- /dev/null
+++ b/ltt/ltt-test-tsc.c
@@ -0,0 +1,116 @@
+/* ltt-test-tsc.c
+ *
+ * Test TSC synchronization
+ */
+#include <linux/module.h>
+#include <linux/timer.h>
+#include <asm/timex.h>
+#include <linux/jiffies.h>
+#include <linux/cpu.h>
+#include <linux/kthread.h>
+#include <linux/mutex.h>
+#include <linux/ltt-tracer.h>
+
+/* Workaround for 32 bits arch which does not define this */
+#ifdef CONFIG_X86_32
+#define get_cycles_sync get_cycles
+#endif
+
+#define MAX_CYCLES_DELTA 1000ULL
+
+static DEFINE_PER_CPU(cycles_t, tsc_count) = 0;
+static DECLARE_MUTEX(tscsync_mutex);
+
+static DEFINE_PER_CPU(int, wait_sync);
+static DEFINE_PER_CPU(int, wait_end_sync);
+
+int ltt_tsc_is_sync = 1;
+EXPORT_SYMBOL(ltt_tsc_is_sync);
+cycles_t ltt_last_tsc = 0;
+EXPORT_SYMBOL(ltt_last_tsc);
+
+/* Mark it noinline so we make sure it is not unrolled.
+ * Wait until value is reached. */
+static noinline void tsc_barrier(long wait_cpu, int value)
+{
+	sync_core();
+	per_cpu(wait_sync, smp_processor_id())--;
+	do {
+		barrier();
+	} while(unlikely(per_cpu(wait_sync, wait_cpu) > value));
+	__get_cpu_var(tsc_count) = get_cycles_sync();
+}
+
+/* worker thread called on each CPU.
+ * First wait with interrupts enabled, then wait with interrupt disabled,
+ * for precision. We are already bound to one CPU. */
+static void test_sync(void *arg)
+{
+	long wait_cpu = (long)arg;
+	unsigned long flags;
+
+	local_irq_save(flags);
+	tsc_barrier(wait_cpu, 1); /* Make sure the instructions are in I-CACHE */
+	tsc_barrier(wait_cpu, 0);
+	per_cpu(wait_end_sync, smp_processor_id())--;
+	do {
+		barrier();
+	} while(unlikely(per_cpu(wait_end_sync, wait_cpu) > 0));
+	local_irq_restore(flags);
+}
+
+/* Do loops (making sure no unexpected event changes the timing), keep the
+ * best one. The result of each loop is the highest tsc delta between the
+ * master CPU and the slaves. */
+static int test_tsc_synchronization(void)
+{
+	long cpu, master;
+	cycles_t max_diff = 0, diff, best_loop, worse_loop = 0;
+	int i;
+
+	down(&tscsync_mutex);
+	preempt_disable();
+	master = smp_processor_id();
+	for_each_online_cpu(cpu) {
+		if (master == cpu)
+			continue;
+		best_loop = ULLONG_MAX;
+		for (i = 0; i < 10; i++) {
+			/* Each CPU (master and slave) must decrement the
+			 * wait_sync value twice (one for priming in cache) */
+			//atomic_set(&wait_sync, 4);
+			//atomic_set(&wait_end_sync, 2);
+			per_cpu(wait_sync, master) = 2;
+			per_cpu(wait_sync, cpu) = 2;
+			per_cpu(wait_end_sync, master) = 1;
+			per_cpu(wait_end_sync, cpu) = 1;
+			smp_call_function_single(cpu, test_sync,
+						(void*)master, 1, 0);
+			test_sync((void*)cpu);
+			diff = abs(per_cpu(tsc_count, cpu)
+				- per_cpu(tsc_count, master));
+			best_loop = min(best_loop, diff);
+			worse_loop = max(worse_loop, diff);
+		}
+		max_diff = max(best_loop, max_diff);
+	}
+	preempt_enable();
+	if (max_diff >= MAX_CYCLES_DELTA) {
+		printk(KERN_WARNING
+			"LTTng : Your timestamp counter is not reliable.\n"
+			"See LTTng documentation to find the "
+			"appropriate solution for your architecture.\n");
+		printk("TSC unsynchronized : %llu cycles delta is over "
+			"threshold %llu\n", max_diff, MAX_CYCLES_DELTA);
+	}
+	up(&tscsync_mutex);
+	return max_diff < MAX_CYCLES_DELTA;
+}
+EXPORT_SYMBOL_GPL(test_tsc_synchronization);
+
+static int __init tsc_test_init(void)
+{
+	ltt_tsc_is_sync = test_tsc_synchronization();
+	return 0;
+}
+__initcall(tsc_test_init);
